/*
 *  Copyright (c) 2006           Ji YongGang <jungle@soforge.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __CHMSEE_H__
#define __CHMSEE_H__

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

enum {
        TITLE_COLUMN,
        FILENAME_COLUMN,
        ID_COLUMN,
        NUM_COLUMNS
};

#define GLADE_FILE "chmsee.glade"
#define CHMSEE_NO_LINK "chmsee_no_link"
#define CHMSEE_HELP "ChmSee.html"

#ifdef _DEBUG
#  define LOG_DEBUG(format, message) g_debug(format, message)
#  define LOG_INFO(message) g_message(message)
#else
#  define LOG_DEBUG(format, message)
#  define LOG_INFO(message)
#endif

typedef struct _ChmSee ChmSee;

struct _ChmSee {
        /* default window */
        GtkWidget       *window;
        
        /* toolbar */
        GtkWidget       *toolbar_back;
        GtkWidget       *toolbar_search;
        GtkWidget       *toolbar_forward;
        GtkWidget       *toolbar_home;
        GtkWidget       *toolbar_small;
        GtkWidget       *toolbar_big;
        GtkWidget       *toolbar_reset;
        GtkWidget       *toolbar_showw;
        
        /* notebook */
        GtkWidget       *chm_pw;
        GtkWidget       *nb_entry;
        GtkWidget       *nb_button_contents;

        /* Contents */
        GtkWidget       *chm_tree;
        
        /* bookmark */
        GtkWidget       *nb_bookmark_treeview;
        GtkWidget       *nb_bookmark_entry;
        GtkWidget       *nb_button_bookmark_add;
        gchar           *bookmark_title;
        const gchar     *bookmark_uri;
        
        /* htmlview */
        GtkWidget       *chm_html;
        GList           *link;
        guint           link_pos;
        gchar           *current_link;
        gchar           *home_url;
        const gchar     *hhc_name;
        const gchar     *hhk_name;
        const gchar     *current_codeset;
        
        /* charset */
        GtkWidget       *char_treeview;
        GtkWidget       *char_checkbtn;
        gint            is_always;

        /* books info */
        gchar           *cache_dir;
        gchar           *book_dir;
        gchar           *book_md5;
        gchar           *bookinfo;

        /* other */
        gchar           *home;
        gchar           *last_dir;
        gchar           *bookmarks;
        gchar           *last_chm;
        gchar           *config;
        const gchar     *chm_name;
};

ChmSee *chmsee_new(void);

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#endif /* !__CHMSEE_H__ */
