/*
 *  Copyright (c) 2006           Ji YongGang <jungle@soforge.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/***************************************************************************
 *   Copyright (C) 2003,2004 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// #include <sys/types.h>
// #include <dirent.h>
// #include <unistd.h>
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include "chmsee.h"
#include "chmsee_config.h"

void 
chmsee_init_config_path(ChmSee *chmsee)
{
        chmsee->last_dir = g_strdup_printf("%s/%s", chmsee->home, "chmsee_lastdir");
        chmsee->bookmarks = g_strdup_printf("%s/%s", chmsee->home, "chmsee_bookmark");
        chmsee->last_chm = g_strdup_printf("%s/%s", chmsee->home, "chmsee_lastchm");
        chmsee->bookinfo = g_strdup_printf("%s/%s", chmsee->cache_dir, "bookinfo");
        chmsee->config = g_strdup_printf("%s/%s", chmsee->home, "chmsee_config");
}

void 
chmsee_load_config(ChmSee *chmsee)
{
        FILE    *fp;
        gchar   *get_tmp;
        gchar   *tmp_always;
        gchar   *ch;
        char    lineBuf[256];

        fp = fopen(chmsee->config, "r");
        
        if (!fp) {
                return;
        }
        
        while (fgets(lineBuf, 512, fp) != NULL) {
                if (( ch = g_strrstr(lineBuf, "ALWAYSUSE="))) {
                        get_tmp = g_strdup(ch + 10);
                        tmp_always = g_strndup(get_tmp, strlen(get_tmp)-1);
                        chmsee->is_always = atoi(tmp_always);

                        g_free(get_tmp);
                        g_free(tmp_always);
                } else if ((ch = g_strrstr(lineBuf, "CHARSET="))) {
                        get_tmp = g_strdup(ch + 8);
                        chmsee->current_codeset = g_strndup(get_tmp, strlen(get_tmp)-1);
                        g_free(get_tmp);
                }
        }
        
        fclose(fp);
}

void 
chmsee_save_config(ChmSee *chmsee)
{
        FILE    *file;
        gchar   *s;
        gchar   *p;

        file = fopen(chmsee->config, "w");
        s = g_strdup_printf("ALWAYSUSE=%d\n", chmsee->is_always);
        p = g_strdup_printf("CHARSET=%s\n", chmsee->current_codeset);
        fprintf(file, s);
        fprintf(file, p);
        g_free(s);
        g_free(p);
        fclose(file);
}

gchar *
chmsee_load_last_chm_dir(ChmSee *chmsee)
{
        gchar *get_dir = NULL;
        
        if (!g_file_test(chmsee->last_dir, G_FILE_TEST_EXISTS)) {
                return (get_dir);
        }

        FILE *fp;
        char lineBuf[256];
        
        fp = fopen(chmsee->last_dir, "r");
        
        if (!fp) {
                return (get_dir);
        }
        
        while (fgets(lineBuf, 512, fp) != NULL) {
                get_dir = g_strdup_printf("%s/", lineBuf);
        }
        
        fclose(fp);

        return (get_dir);
}

void 
chmsee_save_last_chm_dir(ChmSee *chmsee, const gchar *path)
{
        FILE    *file;
        
        file = fopen(chmsee->last_dir, "w");
        fprintf(file, path);
        fclose(file);
}

gchar *
load_hhc_name(ChmSee *chmsee)
{
        gchar *hhc_name = NULL;
        
        FILE *fp;
        char lineBuf[256];
        gchar *get_tmp;
        gchar *ch;
        
        if (!g_file_test(chmsee->bookinfo, G_FILE_TEST_EXISTS)) {
                g_print("bookinfo file lost!\n");
                return (hhc_name);
        }

        fp = fopen(chmsee->bookinfo, "r");
        
        if (!fp) {
                g_print("can not open bookinfo!\n");
                return (hhc_name);
        }
        
        while (fgets(lineBuf, 512, fp) != NULL) {
                if (( ch = g_strstr_len(lineBuf, 512, chmsee->book_md5))) {
                        get_tmp = g_strdup(ch + 33);
                        hhc_name = g_strndup(get_tmp, strlen(get_tmp)-1);
                        g_free(get_tmp);
                }
        }
        
        fclose(fp);

        return (hhc_name);
}

void
save_hhc_name(ChmSee *chmsee)
{
        FILE    *file;
        gchar   *s;

        file = fopen(chmsee->bookinfo, "a+");
        s = g_strdup_printf("%s=%s\n", chmsee->book_md5, chmsee->hhc_name);
        fprintf(file, s);
        fclose(file);
        g_free(s);
}
