/*
 *  Copyright (c) 2006           Ji YongGang <jungle@soforge.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/***************************************************************************
 *   Copyright (C) 2003 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "chmsee.h"
#include "startup.h"
#include "charset.h"
#include "chmfile.h"

int
main(int argc, char *argv[])
{
        ChmSee *chmsee;
        const gchar *filename = NULL;

        /* i18n */
        bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
        bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
        textdomain (GETTEXT_PACKAGE);

        if (!g_thread_supported()) g_thread_init(NULL);

        gtk_init(&argc, &argv);

        /* show splash screen */
        chmsee_startup_popup_new();

        /* create main window */
        chmsee = chmsee_new();

        if (argv[1]) {
                filename = g_strdup_printf("%s", argv[1]);
        }

        if (filename) {
                chmsee->chm_name = g_strdup_printf("%s", filename);
                
                if (chmsee->is_always == 1) {
                        chmsee_go_ex_chm_file(chmsee, chmsee->chm_name);
                } else {
                        chmsee_char_dialog_new (chmsee);
                }
        }

        gtk_widget_show(chmsee->window);

        gtk_main ();

        return 0;
}
