/*
 *  Copyright (c) 2006           Ji YongGang <jungle@soforge.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/***************************************************************************
 *   Copyright (C) 2003 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "chmsee.h"
#include "menu_popup.h"
#include "html.h"
#include "bookmarks.h"

static void on_html_reload_to_setcode(GtkWidget *, gchar *);

static gchar *code_var[] = {
        "GB18030",
        "GB2312",
        "GBK",
        "BIG5",
        "ISO-8859-1",
        "ISO-8859-15",
        "Windows-1252",
        "Shift-JIS",
        "NONE"
};

static void
on_html_reload_to_setcode(GtkWidget *widget, gchar *codeset)
{
        ChmSee *chmsee;
        GtkWidget *menu;

        menu = widget->parent;

        chmsee = g_object_get_data(G_OBJECT (menu), "ChmSee");

        chmsee->current_codeset = g_strdup_printf("%s", codeset);
        LOG_DEBUG ("current ->[%s]", codeset);
        chmsee_html_reload(chmsee, chmsee->current_link);
}

void 
chmsee_menu_popup(GdkEventButton *event, ChmSee *chmsee) 
{
        GladeXML *glade;

        GtkWidget *menu;
        GtkWidget *menu_name;
        GtkWidget *menu_gb18030;
        GtkWidget *menu_gb2312;
        GtkWidget *menu_gbk;
        GtkWidget *menu_big5;
        GtkWidget *menu_hz;
        GtkWidget *menu_iso;
        GtkWidget *menu_window;
        GtkWidget *menu_jp;
        GtkWidget *menu_none;
        GtkWidget *menu_bookmark_add;

        /* create popup menu */
        glade = glade_xml_new(CHMSEE_DATA_DIR"/"GLADE_FILE, "html_popup_menu", NULL);
        menu = glade_xml_get_widget(glade, "html_popup_menu");
        g_object_set_data(G_OBJECT (menu), "ChmSee", chmsee);

        /* connect the signals in the interface */
        menu_name = glade_xml_get_widget(glade, "menu_name");
        gtk_widget_set_sensitive(menu_name, FALSE);
	
        menu_gb18030 = glade_xml_get_widget(glade, "menu_gb18030");
        g_signal_connect(G_OBJECT (menu_gb18030), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[0]);

        menu_gb2312 = glade_xml_get_widget(glade, "menu_gb2312");
        g_signal_connect(G_OBJECT (menu_gb2312), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[1]);

        menu_gbk = glade_xml_get_widget(glade, "menu_gbk");
        g_signal_connect(G_OBJECT (menu_gbk), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[2]);

        menu_big5 = glade_xml_get_widget(glade, "menu_big5");
        g_signal_connect(G_OBJECT (menu_big5), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[3]);

        menu_hz = glade_xml_get_widget(glade, "menu_hz");
        g_signal_connect(G_OBJECT (menu_hz), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[4]);

        menu_iso = glade_xml_get_widget(glade, "menu_iso");
        g_signal_connect(G_OBJECT (menu_iso), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[5]);

        menu_window = glade_xml_get_widget(glade, "menu_window");
        g_signal_connect(G_OBJECT (menu_window), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[6]);

        menu_jp = glade_xml_get_widget(glade, "menu_jp");
        g_signal_connect(G_OBJECT (menu_jp), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[7]);

        menu_none = glade_xml_get_widget(glade, "menu_none");
        g_signal_connect(G_OBJECT (menu_none), 
                         "activate",
                         G_CALLBACK (on_html_reload_to_setcode), 
                         code_var[8]);

        menu_bookmark_add = glade_xml_get_widget(glade, "menu_bookmark_add");
        g_signal_connect(G_OBJECT (menu_bookmark_add), 
                         "activate",
                         G_CALLBACK(chmsee_html_bookmark_add), 
                         chmsee);

        gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button, event->time);
}
