/*
 *  Copyright (c) 2006           Ji YongGang <jungle@soforge.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/***************************************************************************
 *   Copyright (C) 2003 by zhong                                           *
 *   zhongz@163.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "chmsee.h"
#include "chmsee_config.h"
#include "setup.h"
#include "chmfile.h"

static void on_setup_window_clear(GtkWidget *, ChmSee *);
static void on_setup_window_check(GtkWidget *, ChmSee *);
static void on_setup_window_close(GtkButton *, ChmSee *);

static void
on_setup_window_clear(GtkWidget *widget, ChmSee *chmsee)
{
        command_delete_tmpdir(chmsee->cache_dir);
}

static void
on_setup_window_check(GtkWidget *widget, ChmSee *chmsee)
{
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (widget))) {
                chmsee->is_always = 0;
        } else {
                chmsee->is_always = 1;
        }
}

static void 
on_setup_window_close(GtkButton *button, ChmSee *chmsee)
{
        gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET(button)));
}

void
chmsee_setup_window_new(GtkWidget *widget, ChmSee *chmsee)
{
        GladeXML *glade;
        GtkWidget *setup_window;
        GtkWidget *cache_entry;
        GtkWidget *clear_button;
        GtkWidget *check_button;
        GtkWidget *close_button;

        /* create setup window */
        glade = glade_xml_new(CHMSEE_DATA_DIR"/"GLADE_FILE, "setup_window", NULL);
        
        /* connect the signals in the interface */
        setup_window = glade_xml_get_widget(glade, "setup_window");
        g_signal_connect_swapped((gpointer) setup_window, 
                                 "destroy",
                                 G_CALLBACK (gtk_widget_destroy),
                                 GTK_OBJECT (setup_window));

        cache_entry = glade_xml_get_widget(glade, "entry_cache_dir");
        gtk_entry_set_text(GTK_ENTRY(cache_entry), chmsee->cache_dir);

        clear_button = glade_xml_get_widget(glade, "chm_setup_clear");
        g_signal_connect((gpointer) clear_button, 
                         "clicked",
                         G_CALLBACK (on_setup_window_clear),
                         chmsee);
        
        check_button = glade_xml_get_widget(glade, "chm_setup_check");

        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (check_button), 
                                     !(gboolean)chmsee->is_always);
        g_signal_connect(check_button, 
                         "toggled",
                         G_CALLBACK (on_setup_window_check),
                         chmsee);

        close_button = glade_xml_get_widget(glade, "chm_setup_close");
        g_signal_connect(close_button, 
                         "clicked",
                         G_CALLBACK (on_setup_window_close),
                         chmsee);
}
